﻿function AddCustomMenuItems(menu) {
  menu.AddItem("Shuffle", options("Shuffle")?gddMenuItemFlagChecked:0, SwitchShuffle);
  menu.AddItem("Repeat", options("Repeat")?gddMenuItemFlagChecked:0, SwitchRepeat); 
}

function SwitchShuffle() {
  options("Shuffle") = !options("Shuffle");
  _wmp.settings.setMode("shuffle", options("Shuffle"));
}

function SwitchRepeat() {
    options("Repeat") = !options("Repeat");
    _wmp.settings.setMode("loop", options("Repeat"));
}

function ShowOptions(wnd) {
  wnd.AddControl(gddWndCtrlClassLabel,gddWndCtrlTypeNone,"", "Music file types to search",10,0,200,20);
  var x=20;
  var y=15;
  var cntrlButton;
  for(i=0;i<allowedMusicTypes.length;i++){
     if(i != 0){
           if(i%4==0) {x =20 ; y +=20;}
           else if(i%3==0) {x =100 ;}
           else if(i%2==0) {x =20 ; y +=20;}
           else {x =100 ;}
     }
    cntrlButton = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, allowedMusicTypes[i],
    allowedMusicTypes[i], x, y, 80, 20);
    cntrlButton.value = options(allowedMusicTypes[i]);
  }
  
  y+=20;
  wnd.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", "Additional Filters for Music Search:",
    10, y, 220, 20);
  y+=20;
  wnd.AddControl(gddWndCtrlClassEdit, 0, "adfMusic", options.GetValue("adfMusic"),
    10, y, 220, 24);
  y+=25;
  wnd.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", '(eg. under:"c:\\music" |filetype:ogg)',
    10, y, 220, 20);
  y+=25;
  wnd.AddControl(gddWndCtrlClassLabel,gddWndCtrlTypeNone,"", "Movie file types to search",10,y,200,20);

 x=20;
 y +=20;
  for(i=0;i<allowedMovieTypes.length;i++){
     if(i != 0){
           if(i%4==0) {x =20 ; y +=20;}
           else if(i%3==0) {x =100 ;}
           else if(i%2==0) {x =20 ; y +=20;}
           else {x =100 ;}
     }
    cntrlButton = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, allowedMovieTypes[i],
    allowedMovieTypes[i], x, y, 80, 20);
    cntrlButton.value = options(allowedMovieTypes[i]);
  }
   
 y +=25;
  wnd.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", "Additional Filters for Movie Search:",10, y, 220, 20);
 
 y+=20;
  wnd.AddControl(gddWndCtrlClassEdit, 0, "adfMovie", options.GetValue("adfMovie"),10, y, 220, 24);

 y+=25;
  wnd.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", '(eg. under:"c:\\movies" |filetype:divx)',10, y, 220, 20);

 y+=25;
  wnd.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", "Number of Files Per page: ",10, y, 220, 20);

  wnd.AddControl(gddWndCtrlClassEdit, 0, "filesPerPage", options.GetValue("filesPerPage"),140, y, 40, 20);

  wnd.onClose = OptionsDlgClosed;
}


function OptionsDlgClosed(wnd, code) {
  if (code == gddIdOK) {
	  for(i=0;i<allowedMusicTypes.length;i++){
	    options(allowedMusicTypes[i]) = wnd.GetControl(allowedMusicTypes[i]).value;
	  }
          options("adfMusic")=wnd.GetControl("adfMusic").value;
	  for(i=0;i<allowedMovieTypes.length;i++){
	    options(allowedMovieTypes[i]) = wnd.GetControl(allowedMovieTypes[i]).value;
	  }
          options("adfMovie")=wnd.GetControl("adfMovie").value;
          options("filesPerPage")=wnd.GetControl("filesPerPage").value;
  }
}

plugin.onAddCustomMenuItems = AddCustomMenuItems;
plugin.onShowOptionsDlg = ShowOptions;
initialize();