﻿function Query(queryStr){
 this.execute = function(){
    var i;
    var q = queryAPI.QueryEx(queryStr , i, i);
    q.SetOption("async", false);
    return this.parseresults(q.Execute());
  }

this.parseresults = function(results) {
    var toReturn=new Array();
    var result = null;
    var fileName;
    var artistName;
    var albumName;
    while ((result = results.Next()) != null) {      
    try {
      if (result.schema == GD_MEDIA_FILE || result.schema == GD_FILE){
         var path = result(PATH_FILE);
         if (fso.FileExists(path) && path.substring(0,7) != "archive") {
             fileName=path.substring(path.lastIndexOf("\\")+1,path.lastIndexOf("."));
             fileName = cleanString(fileName);
             try{fileName += "~:" + result(ARTIST_FILE) + ":~";
             }catch(e){fileName += "~:-:~";}

             try{fileName += "~!" + result(ALBUM_FILE) + "!~";
             }catch(e){fileName += "~!-!~";}
             //Type
             fileName +=  "~*"+ path.substring(path.lastIndexOf(".")+1)+"*~";
             toReturn[toReturn.length]= "~E~" + fileName + NU_SEPRTR + path;
         }
       }
      } catch(e) {
      debug.error(e);
     }
    }
   return toReturn;
  }
}

function queryMediaFiles(qtype){
	var query="";
	if(qtype == LIST_SONGS){
          query = options.GetValue("adfMusic");
	  for(i=0;i<allowedMusicTypes.length;i++){
	    if(options(allowedMusicTypes[i])) query +="|filetype:"+allowedMusicTypes[i] + " ";
	  }     
	localSongsList=(new Query(query)).execute();
        localSongsList.sort();
	}else if(qtype == LIST_MOVIES_VIDEOS){
          query = options.GetValue("adfMovie");
	  for(i=0;i<allowedMovieTypes.length;i++){
	    if(options(allowedMovieTypes[i])) query +="|filetype:"+allowedMovieTypes[i] + " ";
	  }
	  localMoviesList=(new Query(query)).execute();
          localMoviesList.sort();
	}
}

function cleanString(str)
{
  return str.toLowerCase().replace(/[,~=\"_\-?!@#$%^*]/g, " ").replace(/\sand\s/g, " & ").replace(/\s*\s/g, " ").replace(/(^\s*)|(\s*$)/g, "");
}